VERSION 5.00
Begin VB.Form FrmNotifyDialog 
   Appearance      =   0  '2D
   BackColor       =   &H00D67335&
   BorderStyle     =   0  'Kein
   ClientHeight    =   2295
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3465
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Picture         =   "FrmNotifyDialog.frx":0000
   ScaleHeight     =   153
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   231
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Timer TimeoutTimer 
      Left            =   1740
      Top             =   1380
   End
   Begin VB.Timer EffectTimer 
      Left            =   1140
      Top             =   1380
   End
   Begin VB.Label LblText 
      BackStyle       =   0  'Transparent
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   495
      Left            =   360
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label LblExit 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "r"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   9.75
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FDE1CE&
      Height          =   195
      Left            =   2220
      TabIndex        =   0
      Top             =   420
      Width           =   195
   End
End
Attribute VB_Name = "FrmNotifyDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'von Konrad Rudolph
Private Type RECT
    Left    As Long
    Top     As Long
    Right   As Long
    Bottom  As Long
End Type

Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" ( _
  ByVal hWnd As Long, _
  ByVal nIndex As Long _
) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" ( _
  ByVal hWnd As Long, _
  ByVal nIndex As Long, _
  ByVal dwNewLong As Long _
) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32.dll" ( _
  ByVal hWnd As Long, _
  ByVal crKey As Long, _
  ByVal bAlpha As Byte, _
  ByVal dwFlags As Long _
) As Long
Private Declare Function SystemParametersInfo Lib "user32.dll" Alias "SystemParametersInfoA" ( _
  ByVal uAction As Long, _
  ByVal uParam As Long, _
  ByRef lpvParam As Any, _
  ByVal fuWinIni As Long _
) As Long

Private Const GWL_EXSTYLE As Long = (-20)
Private Const WS_EX_LAYERED As Long = &H80000
Private Const SPI_GETWORKAREA As Long = 48

Private Const LWA_ALPHA As Long = &H2

Private Enum EffectDirection
    ShowUp
    ExitOut
End Enum
'----------------------------------------------------

Private m_Effect As NotifyEffects
Private m_Dir As EffectDirection
Private m_EffectDuration As Long
Private m_MaxState As Long
Private m_ScreenClient As RECT
Private m_MaxHeight As Long
'----------------------------------------------------

Public Sub Create( _
  Caption As String, _
  Text As String, _
  Optional Width As Long = 150, _
  Optional Height As Long = 70, _
  Optional Effect As NotifyEffects = NoEffect, _
  Optional Timeout As Long = 4000 _
)
    Call SystemParametersInfo(SPI_GETWORKAREA, 0&, m_ScreenClient, 0&)
    
    If DialogBottom <> 0 Then
        m_ScreenClient.Bottom = DialogBottom
        DialogBottom = DialogBottom - Height
    Else
        DialogBottom = m_ScreenClient.Bottom - Height
    End If
    
    InstanceCount = InstanceCount + 1
    
    Me.Height = Height * Screen.TwipsPerPixelY
    Me.Width = Width * Screen.TwipsPerPixelX
    
    Me.Left = m_ScreenClient.Right * Screen.TwipsPerPixelX - Me.Width
    Me.Top = m_ScreenClient.Bottom * Screen.TwipsPerPixelY - Me.Height
    
    Call PaintForm(Caption, Text)
    
    Select Case Effect
        Case NoEffect
            EffectTimer.Interval = 0
            m_EffectDuration = 0
        Case FadeInOut
            EffectTimer.Interval = 50
            Call SetTransparency(0)
            m_EffectDuration = 600
        Case ScrollUpDown
            EffectTimer.Interval = 20
            Me.Top = m_ScreenClient.Bottom * Screen.TwipsPerPixelY
            m_MaxHeight = Me.Height
            Me.Height = 0
            m_EffectDuration = 700
    End Select
    
    m_MaxState = m_EffectDuration \ 20
    
    m_Effect = Effect
    m_Dir = ShowUp
    
    If Timeout - m_EffectDuration > 0 Then
        TimeoutTimer.Interval = Timeout - m_EffectDuration
        TimeoutTimer.Enabled = True
    End If
    
    ' last action '
    EffectTimer.Enabled = Effect <> NoEffect
    
    Call Me.Show
End Sub

Private Sub EffectTimer_Timer()
    Static State As Long
    
    Select Case m_Dir
        Case ShowUp
            State = State + 1
        Case ExitOut
            State = State - 1
    End Select
    
    If State = m_MaxState + 1 Then
        EffectTimer.Enabled = False
        
        ' ensure effect terminates '
        If m_Effect = FadeInOut Then _
            Call SetTransparency(255)
        Exit Sub
    ElseIf State = 0 Then
        Call Unload(Me)
        Exit Sub
    End If
    
    Select Case m_Effect
        Case NoEffect
        Case FadeInOut
            Call SetTransparency(State * 255 / m_MaxState)
        Case ScrollUpDown
            Me.Height = State * m_MaxHeight / m_MaxState
            Me.Top = m_ScreenClient.Bottom * Screen.TwipsPerPixelY - Me.Height
    End Select
End Sub

'----------------------------------------------------
Private Sub TimeoutTimer_Timer()
    If m_Effect = NoEffect Then
        Call Unload(Me)
        Exit Sub
    End If
    
    m_Dir = ExitOut
    EffectTimer.Enabled = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
FensterschlieenSound
    InstanceCount = InstanceCount - 1
    
    If InstanceCount = 0 Then
        DialogBottom = 0
    End If
NotifySichtbar = False
End Sub

Private Sub LblExit_Click()
    Call Unload(Me)
End Sub

Private Sub PaintForm(Caption As String, Text As String)
    Me.AutoRedraw = True
        
    ' draw caption '
    
    Me.Font.Name = "Verdana"
    Me.Font.Bold = True
    Me.FontSize = 10
    Me.ForeColor = &HD67335
    
    Dim CaptionBack As Gradient
    Dim OffsetRect As RECT
    
    Set CaptionBack = New Gradient
    
    OffsetRect.Left = 1
    OffsetRect.Top = 1
    OffsetRect.Right = Me.ScaleWidth - 2
    OffsetRect.Bottom = Me.TextHeight(Caption) + 2
    Call CaptionBack.DrawGradient(Me.hDC, VarPtr(OffsetRect), &HFDE1CE, &HD67335)
    Me.CurrentX = 2
    Me.CurrentY = 1
    Me.Print Caption
    
    LblText.Caption = Text
    LblText.Left = 2
    LblText.Top = OffsetRect.Bottom + 4
    LblText.Width = Me.ScaleWidth - 4
    LblText.Height = Me.ScaleHeight - LblText.Top - 2
    
    LblExit.Top = 2
    LblExit.Left = Me.ScaleWidth - LblExit.Width - 2
End Sub

Private Sub SetTransparency(Value As Byte)
    If Value = 255 Then
        ' restore opacity '
        Call SetWindowLong( _
            Me.hWnd, _
            GWL_EXSTYLE, _
            GetWindowLong(Me.hWnd, GWL_EXSTYLE) Xor WS_EX_LAYERED _
        )
    Else
        Call SetWindowLong( _
            Me.hWnd, _
            GWL_EXSTYLE, _
            GetWindowLong(Me.hWnd, GWL_EXSTYLE) Or WS_EX_LAYERED _
        )
        Call SetLayeredWindowAttributes(Me.hWnd, 0&, Value, LWA_ALPHA)
    End If
End Sub
