Attribute VB_Name = "mdlNamen_und_Geburtstage"
Option Explicit
'Speicher-Variablen zum Erstellen der notwendigen Dateien
Public Namenliste As String
'die Namen werden in Namenliste.db gespeichert
Dim stNamenlisteTemp As String
Dim iKanalNrName As Integer
Dim NamenNr As Integer

Public Geburtstagsliste As String
'die Geburtstage werden in Geburtstagsliste.db gespeichert
Dim stGeburtstagslisteTemp As String
Dim iKanalNrGeburtstagsliste As Integer
Dim GeburtstagslisteNr As Integer

Public Zhler As Long
Public lngZhler As Long
Public iTage As Integer            'Variable fr die Anzahl der Tage im Monat
Public Monatserster As Date        'Variable fr Monats-Ersten
Public Monatsletzter As Date       'Variable fr Manats-Letzten
Public iTag As Integer             'Variable fr den Tag   (01, 02 usw.)
Public iMonat As Integer           'Variable fr den Monat (01, 02 usw.)
Public Monat As String             'Variable fr den Monat (Januar, Februar usw.)
Public iJahr As Integer            'Variable fr das Jahr  (2004, 2005 usw.)
Public GeburtstagsTermin As Boolean

Public Sub Namenffnen()
On Error GoTo Fehlerbehandlung
Laufwerk = App.Path
'gegebenenfalls \ anhngen
If Right(Laufwerk, 1) <> "\" Then
    Laufwerk = Laufwerk & "\"
End If

'--------------------------------------------------------------------
'ffnen und einlesen der vorhandenen Namen
'--------------------------------------------------------------------
On Error Resume Next
Namenliste = Laufwerk & "Namenliste.db"

iKanalNrName = FreeFile() 'Range Nummer as Integer
'Einlesen der Eintrge in der Namenliste
Open Namenliste For Input As iKanalNrName
'Beim ersten Start des Programms ist die Liste noch leer
    If Err.Number > 0 Then
    'deshalb Prozedur verlassen
        Exit Sub
    End If
    
    Do While Not EOF(iKanalNrName)
        Input #iKanalNrName, stNamenlisteTemp
        FrmKalender.lstNamen.AddItem stNamenlisteTemp
    Loop
    
Close iKanalNrName
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Public Sub NamenSchlieen()
On Error GoTo Fehlerbehandlung
Laufwerk = App.Path
'gegebenenfalls \ anhngen
If Right(Laufwerk, 1) <> "\" Then
    Laufwerk = Laufwerk & "\"
End If
If dr.DriveType = CDRom Then
    Exit Sub
Else
'--------------------------------------------------------------------
'ffnen und schreiben der vorhandenen Namen
'--------------------------------------------------------------------
On Error Resume Next
Namenliste = Laufwerk & "Namenliste.db"

iKanalNrName = FreeFile() 'Range Nummer as Integer
'schreiben der Eintrge von lstNamen in Namenliste.db
Open Namenliste For Output As iKanalNrName
    
   For NamenNr = 0 To FrmKalender.lstNamen.ListCount - 1
        Print #iKanalNrName, FrmKalender.lstNamen.List(NamenNr)
   Next NamenNr
   
Close iKanalNrName
End If
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Sub Geburtstageffnen()
On Error GoTo Fehlerbehandlung
Laufwerk = App.Path
'gegebenenfalls \ anhngen
If Right(Laufwerk, 1) <> "\" Then
    Laufwerk = Laufwerk & "\"
End If

'--------------------------------------------------------------------
'ffnen und einlesen der vorhandenen Geburtstage
'--------------------------------------------------------------------
On Error Resume Next
Geburtstagsliste = Laufwerk & "Geburtstagsliste.db"

iKanalNrGeburtstagsliste = FreeFile() 'Range Nummer as Integer
'Einlesen der Eintrge in der Geburtstagsliste
Open Geburtstagsliste For Input As iKanalNrGeburtstagsliste
'Beim ersten Start des Programms ist die Liste noch leer
    If Err.Number > 0 Then
    'deshalb Prozedur verlassen
        Exit Sub
    End If
    
    Do While Not EOF(iKanalNrGeburtstagsliste)
        Input #iKanalNrGeburtstagsliste, stGeburtstagslisteTemp
        FrmKalender.lstGeburtstage.AddItem stGeburtstagslisteTemp
    Loop
    
Close iKanalNrGeburtstagsliste
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Sub GeburtstageSchlieen()
On Error GoTo Fehlerbehandlung
Laufwerk = App.Path
'gegebenenfalls \ anhngen
If Right(Laufwerk, 1) <> "\" Then
    Laufwerk = Laufwerk & "\"
End If
If dr.DriveType = CDRom Then
    Exit Sub
Else
'--------------------------------------------------------------------
'ffnen und schreiben der vorhandenen Geburtstage
'--------------------------------------------------------------------
On Error Resume Next
Geburtstagsliste = Laufwerk & "Geburtstagsliste.db"

iKanalNrGeburtstagsliste = FreeFile() 'Range Nummer as Integer
'schreiben der Eintrge von lstGeburtstage in Geburtstagliste.db
Open Geburtstagsliste For Output As iKanalNrGeburtstagsliste
    
   For GeburtstagslisteNr = 0 To FrmKalender.lstGeburtstage.ListCount - 1
        Print #iKanalNrGeburtstagsliste, FrmKalender.lstGeburtstage.List(GeburtstagslisteNr)
   Next GeburtstagslisteNr
   
Close iKanalNrGeburtstagsliste
End If
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Public Sub Geburtstagefllen()
On Error GoTo Fehlerbehandlung
Call Freeze
With FrmGeburtstage
    With .MSFlexGridGeburtstage
        '.Height = 4700
        .Width = 4250
        .Rows = FrmKalender.lstNamen.ListCount + 1
        .Cols = 3
        .ColWidth(0) = 500
        .ColWidth(1) = 2500
        
            .TextMatrix(0, 0) = "ID.:"
            .TextMatrix(0, 1) = "Name:"
            .TextMatrix(0, 2) = "Datum:"
            
        If FrmKalender.lstNamen.ListCount > 0 Then
            For i = 1 To FrmKalender.lstNamen.ListCount
                .TextMatrix(i, 0) = i  'die entsprechende Nr. eintragen
                .TextMatrix(i, 1) = FrmKalender.lstNamen.List(i - 1)
                .TextMatrix(i, 2) = FrmKalender.lstGeburtstage.List(i - 1)
            Next
            With FrmGeburtstage
                .cmdEintragAb.Enabled = True
                .cmdEintragAuf.Enabled = True
            End With
        Else
            With FrmGeburtstage
                .lblAlter.Caption = ""
                .cmdEintragAb.Enabled = False
                .cmdEintragAuf.Enabled = False
            End With
        End If
    End With
End With
Call Defrost
Exit Sub
Fehlerbehandlung:
Call Defrost
Fehlermeldung
End Sub

Public Sub Geburtstageanzeigen()
On Error GoTo Fehlerbehandlung
With FrmKalender.lstGeburtstage
Zhler = 0
lngZhler = 0
Call Freeze
If FrmKalender.chkGeburtstage.Value = 1 Then
    If FrmKalender.lstNamen.ListCount > 0 Then
        For i = 0 To .ListCount - 1
            If Month(.List(i)) = FrmKalender.cboMonat.ListIndex + 1 Then
                Zhler = Zhler + 1
            End If
        Next
        
            FrmMonat.Caption = "Geburtstage im " & Monat & " " & iJahr
        If Zhler > 0 Then
            
            With FrmMonat.MSFlexGridAnzeige
                .Cols = 4
                .Rows = Zhler + 1
                .ColWidth(0) = 700
                .ColWidth(1) = 3000
                .ColWidth(2) = 1200
                .ColWidth(3) = 1000
                
                .TextMatrix(0, 0) = "lfd. Nr.:"
                .TextMatrix(0, 1) = "Name :"
                .TextMatrix(0, 2) = "Geburtstag :"
                .TextMatrix(0, 3) = "err. Alter :"
                
                For i = 0 To FrmKalender.lstNamen.ListCount - 1
                    If Month(FrmKalender.lstGeburtstage.List(i)) = FrmKalender.cboMonat.ListIndex + 1 Then
                        lngZhler = lngZhler + 1
                        .TextMatrix(lngZhler, 0) = lngZhler
                        .TextMatrix(lngZhler, 1) = FrmKalender.lstNamen.List(i)
                        .TextMatrix(lngZhler, 2) = Left(FrmKalender.lstGeburtstage.List(i), 6)
                        'auf Geburtstag in einem Schaltjahr am 29.02. prfen
                        If Left(FrmKalender.lstGeburtstage.List(i), 6) = "29.02." Then
                        .TextMatrix(lngZhler, 3) = fktAlterGeburtstag(FrmKalender.lstGeburtstage.List(i), _
                                                    "28.02." & iJahr) & " Jahre"
                        Else
                        .TextMatrix(lngZhler, 3) = fktAlterGeburtstag(FrmKalender.lstGeburtstage.List(i), _
                                                    Left(FrmKalender.lstGeburtstage.List(i), 6) & iJahr) & " Jahre"
                        End If
                    End If
                Next
            End With
        Else
            With FrmMonat.MSFlexGridAnzeige
                .Cols = 4
                .Rows = Zhler + 1
                .ColWidth(0) = 700
                .ColWidth(1) = 3000
                .ColWidth(2) = 1200
                .ColWidth(3) = 1000
                
                .TextMatrix(0, 0) = "lfd. Nr.:"
                .TextMatrix(0, 1) = "Name :"
                .TextMatrix(0, 2) = "Geburtstag :"
                .TextMatrix(0, 3) = "err. Alter :"
                
            End With
        End If
        
    End If
End If
Call Defrost
End With
Exit Sub
Fehlerbehandlung:
Call Defrost
End Sub

Public Sub Fehlermeldung()
Screen.MousePointer = vbDefault
FehlerSound
Screen.MousePointer = vbDefault
    MsgBox "Fehler : " & Err.Number & Chr(13) & Err.Description & "," & Chr(13) & Chr(13) _
    & "du kannst dennoch eingeschrnkt oder auch uneingeschrnkt weitermachen !", _
    vbCritical, App.Title & " : Ein Fehler ist aufgetreten !"
Clicksound
End Sub
