Attribute VB_Name = "mdlResSound"
Option Explicit

'Konstante          Bedeutung                                       Wert
'SND_ASYNC          Das Programm wartet nicht bis der Sound         1
'                   abgespielt wurde.

'SND_NODEFAULT      Wenn die angegebene Datei nicht gefunden        2
'                   werden konnte, wird nicht der Standartklang
'                   abgespiel.

'SND_SYNC           Der Programm fhrt erst fort, wenn der Sound    0
'                   abgespielt wurde

'SND_LOOP           Der Sound wird solange wiederholt abgespielt    8
'                   bis die sndPlaySound-Funktion erneut, diesmal
'                   aber mit vbNullString anstelle eines Datei-
'                   namens, aufgerufen wird,

'SND_NOSTOP         Der angegebene Sound wird nicht gespielt,       16
'                   wenn gerade ein anderer Sound gespielt wird.

'*** Sound-Funktionen ***
'----------------------------------------------------------------------------------------
'----------------------------------------------------------------------------------------
'fr das Abspielen aus der Ressource-Datei
Public Const SND_SYNC = &H0
Public Const SND_ASYNC = &H1
Public Const SND_NODEFAULT = &H2
Public Const SND_MEMORY = &H4
Public Const SND_LOOP = &H8
Public Const SND_NOSTOP = &H10
Public Const SND_PURGE = &H40
Public Const SND_NOWAIT = &H2000

Public Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" _
(ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long

Public Const SND_ALIAS = &H10000
Public Const SND_FILENAME = &H20000
Public Const SND_RESOURCE = &H40004
Public strSound As String
Public Flags&
'----------------------------------------------------------------------------------------

Public Sub KalenderffnenSound()
On Error GoTo Fehlerbehandlung
    '** Sound aus Resource spielen
    '** Sound aus Resource holen und in String umwandeln
     strSound = StrConv(LoadResData("KALENDEROEFFNEN", "SOUND"), vbUnicode)
     Flags& = SND_ASYNC Or SND_MEMORY
     PlaySound strSound, 0, Flags&
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub KalenderschlieenSound()
On Error GoTo Fehlerbehandlung
    '** Sound aus Resource spielen
    '** Sound aus Resource holen und in String umwandeln
     strSound = StrConv(LoadResData("KALENDERSCHLIESSEN", "SOUND"), vbUnicode)
     Flags& = SND_NODEFAULT Or SND_MEMORY
     PlaySound strSound, 0, Flags&
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub ClickSound()
On Error GoTo Fehlerbehandlung
    '** Sound aus Resource spielen
    '** Sound aus Resource holen und in String umwandeln
     strSound = StrConv(LoadResData("CLICK", "SOUND"), vbUnicode)
     Flags& = SND_ASYNC Or SND_MEMORY
     PlaySound strSound, 0, Flags&
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub FehlerSound()
On Error GoTo Fehlerbehandlung
    '** Sound aus Resource spielen
    '** Sound aus Resource holen und in String umwandeln
     strSound = StrConv(LoadResData("Fehler", "SOUND"), vbUnicode)
     Flags& = SND_ASYNC Or SND_MEMORY
     PlaySound strSound, 0, Flags&
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub HinweisSound()
On Error GoTo Fehlerbehandlung
    '** Sound aus Resource spielen
    '** Sound aus Resource holen und in String umwandeln
     strSound = StrConv(LoadResData("HINWEIS", "SOUND"), vbUnicode)
     Flags& = SND_ASYNC Or SND_MEMORY
     PlaySound strSound, 0, Flags&
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub FensterffnenSound()
On Error GoTo Fehlerbehandlung
    '** Sound aus Resource spielen
    '** Sound aus Resource holen und in String umwandeln
     strSound = StrConv(LoadResData("FENSTEROEFFNEN", "SOUND"), vbUnicode)
     Flags& = SND_ASYNC Or SND_MEMORY
     PlaySound strSound, 0, Flags&
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub ErinnerungsSound()
On Error GoTo Fehlerbehandlung
    '** Sound aus Resource spielen
    '** Sound aus Resource holen und in String umwandeln
     strSound = StrConv(LoadResData("ERINNERUNG", "SOUND"), vbUnicode)
     Flags& = SND_ASYNC Or SND_MEMORY
     PlaySound strSound, 0, Flags&
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub FensterschliessenSound()
On Error GoTo Fehlerbehandlung
    '** Sound aus Resource spielen
    '** Sound aus Resource holen und in String umwandeln
     strSound = StrConv(LoadResData("FENSTERSCHLIESSEN", "SOUND"), vbUnicode)
     Flags& = SND_ASYNC Or SND_MEMORY
     PlaySound strSound, 0, Flags&
Exit Sub
Fehlerbehandlung:
End Sub
