Attribute VB_Name = "mdlSound"
Option Explicit


'Konstante          Bedeutung                                       Wert
'SND_ASYNC          Das Programm wartet nicht bis der Sound         1
'                   abgespielt wurde.

'SND_NODEFAULT      Wenn die angegebene Datei nicht gefunden        2
'                   werden konnte, wird nicht der Standartklang
'                   abgespiel.

'SND_SYNC           Der Programm fhrt erst fort, wenn der Sound    0
'                   abgespielt wurde

'SND_LOOP           Der Sound wird solange wiederholt abgespielt    8
'                   bis die sndPlaySound-Funktion erneut, diesmal
'                   aber mit vbNullString anstelle eines Datei-
'                   namens, aufgerufen wird,

'SND_NOSTOP         Der angegebene Sound wird nicht gespielt,       16
'                   wenn gerade ein anderer Sound gespielt wird.

'*** Sound-Funktionen ***
'----------------------------------------------------------------------------------------
'fr das Abspielen aus der Ressource-Datei
Public Const SND_SYNC = &H0
Public Const SND_ASYNC = &H1
Public Const SND_NODEFAULT = &H2
Public Const SND_MEMORY = &H4
Public Const SND_LOOP = &H8
Public Const SND_NOSTOP = &H10
Public Const SND_PURGE = &H40
Public Const SND_NOWAIT = &H2000

'Public Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" _
(ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Public Declare Function sndPlaySoundA Lib "Winmm" (ByVal IpszSoundName As String, _
        ByVal fuOptions As Integer) As Integer

Public Sound$
'----------------------------------------------------------------------------------------


Public Sub Startsound()
With FrmKalender
    If .mnuPfadStartSound.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadStartSound.Caption, 2 Or 1)
    End If
End With
End Sub

Public Sub Clicksound()
With FrmKalender
    If .mnuPfadClickSound.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadClickSound.Caption, 2 Or 1)
    End If
End With
End Sub

Public Sub ErinnerungsSound()
With FrmKalender
    If .mnuPfadErinnerungsSound.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadErinnerungsSound.Caption, 2 Or 0)  '14
    End If
End With
End Sub

Public Sub Hinweissound()
With FrmKalender
    If .mnuPfadHinweisSound.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadHinweisSound.Caption, 2 Or 1)  '15
    End If
End With
End Sub

Public Sub FehlerSound()
With FrmKalender
    If .mnuPfadFehlerSound.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadFehlerSound.Caption, 2 Or 1)
    End If
End With
End Sub

Public Sub FrageSound()
With FrmKalender
    If .mnuPfadFrageSound.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadFrageSound.Caption, 2 Or 1)
    End If
End With
End Sub

Public Sub AnnehmenSound()
With FrmKalender
    If .mnuPfadAnnehmenSound.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadAnnehmenSound.Caption, 2 Or 1)  '13
    End If
End With
End Sub

Public Sub AblehnenSound()
With FrmKalender
    If .mnuPfadAblehnenSound.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadAblehnenSound.Caption, 2 Or 1)  '11
    End If
End With
End Sub

Public Sub LschSound()
With FrmKalender
    If .mnuPfadLschenSound.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadLschenSound.Caption, 2 Or 1)
    End If
End With
End Sub

Public Sub DateiffnenSound()
With FrmKalender
    If .mnuPfadDateiffnen.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadDateiffnen.Caption, 2 Or 1)
    End If
End With
End Sub

Public Sub DateischlieenSound()
With FrmKalender
    If .mnuPfadDateiSchlieen.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadDateiSchlieen.Caption, 2 Or 1)
    End If
End With
End Sub

Public Sub FensterffnenSound()
With FrmKalender
    If .mnuPfadFensterffnen.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadFensterffnen.Caption, 2 Or 1)
    End If
End With
End Sub

Public Sub FensterschlieenSound()
With FrmKalender
    If .mnuPfadFensterschlieen.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadFensterschlieen.Caption, 2 Or 1)
    End If
End With
End Sub

Public Sub SchlieenSound()
With FrmKalender
    If .mnuPfadSchlieenSound.Caption <> "" Then
        Sound$ = sndPlaySoundA(.mnuPfadSchlieenSound.Caption, 2 Or 0)
    End If
End With
End Sub
