Attribute VB_Name = "mdlTermine"
Option Explicit

Public Stunde As String
Public Minute As String

Public iTermine As Integer

'Speicher-Variablen zum Erstellen der notwendigen Dateien
Public TerminDatumliste As String
Public Termindatum As Date

'die Datums-Angaben werden in TerminDatumliste.db gespeichert
Dim stTerminDatumlisteTemp As String
Dim iKanalNrTerminDatum As Integer
Dim TerminDatumNr As Integer

Public TerminUhrzeitliste As String
'die Uhrzeit-Angaben werden in TerminUhrzeitliste.db gespeichert
Dim stTerminUhrzeitlisteTemp As String
Dim iKanalNrTerminUhrzeitliste As Integer
Dim TerminUhrzeitlisteNr As Integer

Public Terminartliste As String
'die Termin - Arten werden in Terminartliste.db gespeichert
Dim stTerminartlisteTemp As String
Dim iKanalNrTerminartliste As Integer
Dim TerminartlisteNr As Integer

Public Terminbeschreibungliste As String
'die Grnde werden in Terminbeschreibungliste.db gespeichert
Dim stTerminbeschreibunglisteTemp As String
Dim iKanalNrTerminbeschreibungliste As Integer
Dim TerminbeschreibunglisteNr As Integer

Public Terminvorschlagliste As String
'die Grnde werden in Terminbeschreibungliste.db gespeichert
Dim stTerminvorschlaglisteTemp As String
Dim iKanalNrTerminvorschlag As Integer
Dim TerminvorschlagNr As Integer

Public Terminvorhanden As Boolean
Public AktuerTerminvorhanden As Boolean
Public strFeiertag As String
Public DatumamFeiertag As Boolean
Dim SerienTerminDatumVorhanden As Boolean
Public Seriendatum As Date
Public SerienUhrzeit As Date

Public Sub SetValue(ByVal Datum As Date)
If IsDate(Datum) Then
    'Das Drehfeld wird synchronisiert
    FrmTermine.UpDownDatum.Value = CLng(Datum)
End If
End Sub


Public Sub Terminvorschlgeffnen()
On Error GoTo Fehlerbehandlung
Laufwerk = App.Path
'gegebenenfalls \ anhngen
If Right(Laufwerk, 1) <> "\" Then
    Laufwerk = Laufwerk & "\"
End If

'--------------------------------------------------------------------
'ffnen und einlesen der vorhandenen Termin Datumsangaben
'--------------------------------------------------------------------
On Error Resume Next
Terminvorschlagliste = Laufwerk & "Terminvorschlagliste.db"

iKanalNrTerminvorschlag = FreeFile() 'Range Nummer as Integer
'Einlesen der Eintrge in der TerminDatumliste
Open Terminvorschlagliste For Input As iKanalNrTerminvorschlag
'Beim ersten Start des Programms ist die Liste noch leer
    If Err.Number > 0 Then
    'deshalb Prozedur verlassen
        Exit Sub
    End If
    
    Do While Not EOF(iKanalNrTerminvorschlag)
        Input #iKanalNrTerminvorschlag, stTerminvorschlaglisteTemp
        FrmTermine.cboTerminart.AddItem stTerminvorschlaglisteTemp
    Loop
    
Close iKanalNrTerminvorschlag

Exit Sub
Fehlerbehandlung:
'Fehlermeldung
End Sub

Public Sub TerminvorschlgeSchlieen()
On Error GoTo Fehlerbehandlung
Laufwerk = App.Path
'gegebenenfalls \ anhngen
If Right(Laufwerk, 1) <> "\" Then
    Laufwerk = Laufwerk & "\"
End If
If dr.DriveType = CDRom Then
    Exit Sub
Else
'--------------------------------------------------------------------
'ffnen und schreiben der vorhandenen Termin Datumsangaben
'--------------------------------------------------------------------
On Error Resume Next
Terminvorschlagliste = Laufwerk & "Terminvorschlagliste.db"

iKanalNrTerminvorschlag = FreeFile() 'Range Nummer as Integer
'schreiben der Eintrge von cboGericht in TerminDatumliste.db
Open Terminvorschlagliste For Output As iKanalNrTerminvorschlag
    
   For TerminvorschlagNr = 0 To FrmTermine.cboTerminart.ListCount - 1
        Print #iKanalNrTerminvorschlag, FrmTermine.cboTerminart.List(TerminvorschlagNr)
   Next TerminvorschlagNr
   
Close iKanalNrTerminvorschlag
End If

Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Public Sub TerminDatenffnen()
On Error GoTo Fehlerbehandlung
Laufwerk = App.Path
'gegebenenfalls \ anhngen
If Right(Laufwerk, 1) <> "\" Then
    Laufwerk = Laufwerk & "\"
End If

'--------------------------------------------------------------------
'ffnen und einlesen der vorhandenen Termin Datumsangaben
'--------------------------------------------------------------------
On Error Resume Next
TerminDatumliste = Laufwerk & "TerminDatumliste.db"

iKanalNrTerminDatum = FreeFile() 'Range Nummer as Integer
'Einlesen der Eintrge in der TerminDatumliste
Open TerminDatumliste For Input As iKanalNrTerminDatum
'Beim ersten Start des Programms ist die Liste noch leer
    If Err.Number > 0 Then
    'deshalb Prozedur verlassen
        Exit Sub
    End If
    
    Do While Not EOF(iKanalNrTerminDatum)
        Input #iKanalNrTerminDatum, stTerminDatumlisteTemp
        FrmKalender.lstTerminDatum.AddItem stTerminDatumlisteTemp
    Loop
    
Close iKanalNrTerminDatum


'--------------------------------------------------------------------
'ffnen und einlesen der vorhandenen Termin Uhrzeitangaben
'--------------------------------------------------------------------
On Error Resume Next
TerminUhrzeitliste = Laufwerk & "TerminUhrzeitliste.db"

iKanalNrTerminUhrzeitliste = FreeFile() 'Range Nummer as Integer
'Einlesen der Eintrge in der TerminUhrzeitliste
Open TerminUhrzeitliste For Input As iKanalNrTerminUhrzeitliste
'Beim ersten Start des Programms ist die Liste noch leer
    If Err.Number > 0 Then
    'deshalb Prozedur verlassen
        Exit Sub
    End If
    
    Do While Not EOF(iKanalNrTerminUhrzeitliste)
        Input #iKanalNrTerminUhrzeitliste, stTerminUhrzeitlisteTemp
        FrmKalender.lstTerminUhrzeit.AddItem stTerminUhrzeitlisteTemp
    Loop
    
Close iKanalNrTerminUhrzeitliste


'--------------------------------------------------------------------
'ffnen und einlesen der vorhandenen Termin - Arten
'--------------------------------------------------------------------
On Error Resume Next
Terminartliste = Laufwerk & "Terminartliste.db"

iKanalNrTerminartliste = FreeFile() 'Range Nummer as Integer
'Einlesen der Eintrge in der Terminartliste
Open Terminartliste For Input As iKanalNrTerminartliste
'Beim ersten Start des Programms ist die Liste noch leer
    If Err.Number > 0 Then
    'deshalb Prozedur verlassen
        Exit Sub
    End If
    
    Do While Not EOF(iKanalNrTerminartliste)
        Input #iKanalNrTerminartliste, stTerminartlisteTemp
        FrmKalender.lstTerminart.AddItem stTerminartlisteTemp
    Loop
    
Close iKanalNrTerminartliste

'--------------------------------------------------------------------
'ffnen und einlesen der vorhandenen Termin Grnde
'--------------------------------------------------------------------
On Error Resume Next
Terminbeschreibungliste = Laufwerk & "Terminbeschreibungliste.db"

iKanalNrTerminbeschreibungliste = FreeFile() 'Range Nummer as Integer
'Einlesen der Eintrge in der Terminbeschreibungliste
Open Terminbeschreibungliste For Input As iKanalNrTerminbeschreibungliste
'Beim ersten Start des Programms ist die Liste noch leer
    If Err.Number > 0 Then
    'deshalb Prozedur verlassen
        Exit Sub
    End If
    
    Do While Not EOF(iKanalNrTerminbeschreibungliste)
        Input #iKanalNrTerminbeschreibungliste, stTerminbeschreibunglisteTemp
        FrmKalender.lstTerminbeschreibung.AddItem stTerminbeschreibunglisteTemp
    Loop
    
Close iKanalNrTerminbeschreibungliste

Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Public Sub TerminDatenSchlieen()
On Error GoTo Fehlerbehandlung
Laufwerk = App.Path
'gegebenenfalls \ anhngen
If Right(Laufwerk, 1) <> "\" Then
    Laufwerk = Laufwerk & "\"
End If
If dr.DriveType = CDRom Then
    Exit Sub
Else
'--------------------------------------------------------------------
'ffnen und schreiben der vorhandenen Termin Datumsangaben
'--------------------------------------------------------------------
On Error Resume Next
TerminDatumliste = Laufwerk & "TerminDatumliste.db"

iKanalNrTerminDatum = FreeFile() 'Range Nummer as Integer
'schreiben der Eintrge von cboGericht in TerminDatumliste.db
Open TerminDatumliste For Output As iKanalNrTerminDatum
    
   For TerminDatumNr = 0 To FrmKalender.lstTerminDatum.ListCount - 1
        Print #iKanalNrTerminDatum, FrmKalender.lstTerminDatum.List(TerminDatumNr)
   Next TerminDatumNr
   
Close iKanalNrTerminDatum


'--------------------------------------------------------------------
'ffnen und schreiben der vorhandenen Termin Uhrzeitangaben
'--------------------------------------------------------------------
On Error Resume Next
TerminUhrzeitliste = Laufwerk & "TerminUhrzeitliste.db"

iKanalNrTerminUhrzeitliste = FreeFile() 'Range Nummer as Integer
'schreiben der Eintrge von cboGericht in TerminDatumliste.db
Open TerminUhrzeitliste For Output As iKanalNrTerminUhrzeitliste
    
   For TerminUhrzeitlisteNr = 0 To FrmKalender.lstTerminUhrzeit.ListCount - 1
        Print #iKanalNrTerminUhrzeitliste, FrmKalender.lstTerminUhrzeit.List(TerminUhrzeitlisteNr)
   Next TerminUhrzeitlisteNr
   
Close iKanalNrTerminUhrzeitliste


'--------------------------------------------------------------------
'ffnen und schreiben der vorhandenen Termin - Arten
'--------------------------------------------------------------------
On Error Resume Next
Terminartliste = Laufwerk & "Terminartliste.db"

iKanalNrTerminartliste = FreeFile() 'Range Nummer as Integer
'schreiben der Eintrge von cboGericht in Terminbeschreibungliste.db
Open Terminartliste For Output As iKanalNrTerminartliste
    
   For TerminartlisteNr = 0 To FrmKalender.lstTerminart.ListCount - 1
        Print #iKanalNrTerminartliste, FrmKalender.lstTerminart.List(TerminartlisteNr)
   Next TerminartlisteNr
   
Close iKanalNrTerminartliste

'--------------------------------------------------------------------
'ffnen und schreiben der vorhandenen Termin Grnde
'--------------------------------------------------------------------
On Error Resume Next
Terminbeschreibungliste = Laufwerk & "Terminbeschreibungliste.db"

iKanalNrTerminbeschreibungliste = FreeFile() 'Range Nummer as Integer
'schreiben der Eintrge von cboGericht in Terminbeschreibungliste.db
Open Terminbeschreibungliste For Output As iKanalNrTerminbeschreibungliste
    
   For TerminbeschreibunglisteNr = 0 To FrmKalender.lstTerminbeschreibung.ListCount - 1
        Print #iKanalNrTerminbeschreibungliste, FrmKalender.lstTerminbeschreibung.List(TerminbeschreibunglisteNr)
   Next TerminbeschreibunglisteNr
   
Close iKanalNrTerminbeschreibungliste
End If
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Public Sub Terminefllen()
On Error GoTo Fehlerbehandlung
Call Freeze
With FrmTermine
    With .MSFlexGridTermine
        '.Height = 4700
        '.Width = 4250
        .Rows = FrmKalender.lstTerminDatum.ListCount + 1
        .Cols = 5
        .ColWidth(0) = 700
        .ColWidth(1) = 1000
        .ColWidth(2) = 800
        .ColWidth(3) = 3000
        .ColWidth(4) = 5200
            .TextMatrix(0, 0) = "lfd. Nr.:"
            .TextMatrix(0, 1) = "Datum:"
            .TextMatrix(0, 2) = "Uhrzeit:"
            .TextMatrix(0, 3) = "Termin - Art:"
            .TextMatrix(0, 4) = "Termin - Beschreibung:"
            
        If FrmKalender.lstTerminDatum.ListCount > 0 Then
            For I = 1 To FrmKalender.lstTerminDatum.ListCount
                .TextMatrix(I, 0) = I  'die entsprechende Nr. eintragen
                .TextMatrix(I, 1) = FrmKalender.lstTerminDatum.List(I - 1)
                .TextMatrix(I, 2) = FrmKalender.lstTerminUhrzeit.List(I - 1)
                .TextMatrix(I, 3) = FrmKalender.lstTerminart.List(I - 1)
                .TextMatrix(I, 4) = FrmKalender.lstTerminbeschreibung.List(I - 1)
            Next
            With FrmTermine
                .cmdTerminAb.Enabled = True
                .cmdTerminAuf.Enabled = True
            End With
        Else
            With FrmTermine
                .cmdTerminAb.Enabled = False
                .cmdTerminAuf.Enabled = False
            End With
        End If
    End With
End With
Call Defrost
Exit Sub
Fehlerbehandlung:
Call Defrost
Fehlermeldung
End Sub

Public Sub Termineanzeigen()
On Error GoTo Fehlerbehandlung
With FrmKalender.lstTerminUhrzeit
AktuerTerminvorhanden = False
Zhler = 0
lngZhler = 0
Call Freeze
Dim Datum As Date
Datum = Right(FrmKalender.lblAnzeige.Caption, 10)
Dim Termindatum As Date
iTermine = 0
    With FrmKalender.lstTerminDatum
    For I = 0 To .ListCount - 1
        If .List(I) = Datum Then
            iTermine = iTermine + 1
        End If
    Next
    End With
    
    If iTermine > 0 Then

        Dim Vergleichsdatum As Date
        Vergleichsdatum = Right(FrmKalender.lblAnzeige.Caption, 10)
        Dim Differenztage As Integer
        'die Tage der Differenz zum Termin ausrechnen
            Differenztage = DateDiff("d", Date, Vergleichsdatum)

        With FrmDatumTermin.MSFlexGridTermin
            .Cols = 4
            .Rows = iTermine + 1
            .ColWidth(0) = 700
            .ColWidth(1) = 800
            .ColWidth(2) = 3000
            .ColWidth(3) = 5200
            
            .TextMatrix(0, 0) = "lfd. Nr.:"
            .TextMatrix(0, 1) = "Uhrzeit:"
            .TextMatrix(0, 2) = "Termin - Art:"
            .TextMatrix(0, 3) = "Termin - Beschreibung:"
            
            iTermine = 0
                For I = 1 To FrmKalender.lstTerminDatum.ListCount
                    Termindatum = FrmKalender.lstTerminDatum.List(I - 1)
                    If Termindatum = Datum Then
                        iTermine = iTermine + 1
                        .TextMatrix(iTermine, 0) = iTermine
                        .TextMatrix(iTermine, 1) = FrmKalender.lstTerminUhrzeit.List(I - 1)
                        .TextMatrix(iTermine, 2) = FrmKalender.lstTerminart.List(I - 1)
                        .TextMatrix(iTermine, 3) = FrmKalender.lstTerminbeschreibung.List(I - 1)
                    End If
                Next
        End With
        AktuerTerminvorhanden = True
        If Differenztage < 0 Then
            FrmDatumTermin.Caption = "Termine am : " & Datum _
            & " (Termin ist bereits verstrichen)"
        ElseIf Differenztage = 0 Then
            FrmDatumTermin.Caption = "Termine am : " & Datum & " (heute)"
        Else
            FrmDatumTermin.Caption = "Termine am : " & Datum & " (ist in " _
            & Differenztage & " Tage/n)"
        End If
        FrmDatumTermin.mnuberschrift.Caption = "Termine am : " & Datum
        FrmDatumTermin.Show
    Else
        Unload FrmDatumTermin
    End If
Call Defrost
End With
Exit Sub
Fehlerbehandlung:
Call Defrost
End Sub

Public Sub TerminVerschieben(Richtung As Integer)
Clicksound
Dim strTerminDatumalt As String
Dim strTerminUhrzeitalt As String
Dim strTerminartalt  As String
Dim strTerminbeschreibungalt As String
Dim iNrNeu As Integer, iNrAlt As Integer
With FrmKalender.lstTerminDatum
    If .ListIndex = -1 Then
        FehlerSound
        MsgBox "Bitte erst einen Termin auswhlen!", vbExclamation, "kein Termin ausgewhlt"
        Clicksound
        Exit Sub
    End If
    
    If .ListIndex = .ListCount And Richtung = 1 Then
        Exit Sub
    End If
    
    If .ListIndex = 0 And Richtung = -1 Then
        Exit Sub
    End If
    
    iNrAlt = .ListIndex 'alter Listenindex
    iNrNeu = iNrAlt + Richtung
    If iNrNeu = .ListCount Then
        Exit Sub
    End If
    
    'Nr.. Name und Pfad des aktuellen Eintrags holen
    iNrAlt = .ListIndex
    FrmKalender.lstTerminUhrzeit.ListIndex = .ListIndex
    FrmKalender.lstTerminart.ListIndex = .ListIndex
    FrmKalender.lstTerminbeschreibung.ListIndex = .ListIndex
    
    strTerminDatumalt = .Text
    strTerminUhrzeitalt = FrmKalender.lstTerminUhrzeit.Text
    strTerminartalt = FrmKalender.lstTerminart.Text
    strTerminbeschreibungalt = FrmKalender.lstTerminbeschreibung.Text
    'Aktuellen Eintrag lschen
    .RemoveItem iNrAlt
    FrmKalender.lstTerminUhrzeit.RemoveItem iNrAlt
    FrmKalender.lstTerminart.RemoveItem iNrAlt
    FrmKalender.lstTerminbeschreibung.RemoveItem iNrAlt
    
    'Neuer Eintrag
    .AddItem strTerminDatumalt, iNrNeu
    .ListIndex = iNrNeu
    FrmKalender.lstTerminUhrzeit.AddItem strTerminUhrzeitalt, iNrNeu
    FrmKalender.lstTerminart.AddItem strTerminartalt, iNrNeu
    FrmKalender.lstTerminbeschreibung.AddItem strTerminbeschreibungalt, iNrNeu
    Terminefllen
End With
End Sub

Public Sub TerminReihe_Spalte_anzeigen()
On Error GoTo Fehlerbehandlung
If FrmKalender.lstTerminDatum.ListCount > 0 Then
    With FrmTermine.MSFlexGridTermine
        'MsgBox .Row & " " & .Col, vbInformation
        FrmTermine.lblReihe.Caption = "Reihe : " & .Row
        FrmTermine.lblSpalte.Caption = "Spalte : " & .Col
            If FrmKalender.lstTerminDatum.ListCount <> 0 Then
                With FrmTermine
                    FrmKalender.lstTerminDatum.ListIndex = .MSFlexGridTermine.Row - 1
                    FrmKalender.lstTerminUhrzeit.ListIndex = .MSFlexGridTermine.Row - 1
                    FrmKalender.lstTerminart.ListIndex = .MSFlexGridTermine.Row - 1
                    FrmKalender.lstTerminbeschreibung.ListIndex = .MSFlexGridTermine.Row - 1

                End With
            End If
    End With
End If
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub Terminlschen()
On Error GoTo Fehlerbehandlung
With FrmTermine.MSFlexGridTermine
If FrmKalender.lstTerminDatum.ListCount > 0 Then
    If .Col = 1 Then
        FrageSound
        If MsgBox("soll der Termin :" & Chr(13) & Chr(13) & "Datum : " _
        & .TextMatrix(.Row, .Col) _
        & Chr(13) & Chr(13) & "Uhrzeit : " & .TextMatrix(.Row, .Col + 1) & Chr(13) _
        & Chr(13) & "Termin - Art : " & .TextMatrix(.Row, .Col + 2) & Chr(13) _
        & Chr(13) & "Termin - Beschreibung : " & .TextMatrix(.Row, .Col + 3) & Chr(13) _
        & Chr(13) & "gelscht werden ?", _
        vbQuestion + vbDefaultButton1 + vbYesNo, "Termin lschen") = vbYes Then
        
            FrmKalender.lstTerminDatum.RemoveItem .Row - 1
            FrmKalender.lstTerminUhrzeit.RemoveItem .Row - 1
            FrmKalender.lstTerminart.RemoveItem .Row - 1
            FrmKalender.lstTerminbeschreibung.RemoveItem .Row - 1
            LschSound
            Terminefllen
        Else
            AblehnenSound
        End If
    End If
    TerminReihe_Spalte_anzeigen
Else
    FehlerSound
    MsgBox "Es ist kein Termin zum Lschen vorhanden !", vbExclamation
    Clicksound
End If
End With
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub Terminndern()
Dim Termindatum As Date
On Error GoTo Fehlerbehandlung
With FrmTermine.MSFlexGridTermine
If FrmKalender.lstTerminDatum.ListCount > 0 Then
    If .Col = 1 Then
        FrageSound
        If MsgBox("soll der Termin :" & Chr(13) & Chr(13) & "Datum : " _
        & .TextMatrix(.Row, .Col) _
        & Chr(13) & Chr(13) & "Uhrzeit : " & .TextMatrix(.Row, .Col + 1) & Chr(13) _
        & Chr(13) & "Termin - Art : " & .TextMatrix(.Row, .Col + 2) & Chr(13) _
        & Chr(13) & "Termin - Beschreibung : " & .TextMatrix(.Row, .Col + 3) & Chr(13) _
        & Chr(13) & "gendert werden ?", _
        vbQuestion + vbDefaultButton1 + vbYesNo, "Termin ndern") = vbYes Then
            AnnehmenSound
            Termindatum = .TextMatrix(.Row, .Col)
            FrmTermine.UpDownDatum.Value = CLng(Termindatum)
            Minute = Right(.TextMatrix(.Row, .Col + 1), 2)
            Stunde = Left(.TextMatrix(.Row, .Col + 1), 2)
            FrmTermine.UpDownMinute.Value = Minute
            FrmTermine.UpDownStunde.Value = Stunde
            FrmTermine.cboTerminart.Text = .TextMatrix(.Row, .Col + 2)
            FrmTermine.txtTerminBeschreibung.Text = .TextMatrix(.Row, .Col + 3)
            
            FrmTermine.cmdbernehmen.Caption = "ndern"
        Else
            AblehnenSound
            FrmTermine.cmdbernehmen.Caption = "bernehmen"
        End If
            Termindatumprfen
    End If
    TerminReihe_Spalte_anzeigen
Else
    FehlerSound
    MsgBox "Es ist kein Termin zum ndern vorhanden !", vbExclamation
    Clicksound
End If
End With
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Public Sub Termindatumprfen()
On Error GoTo Fehlerbehandlung
Dim Vergleichszeit As Date
With FrmTermine
    If Termindatum < Date Then
        FehlerSound
        .cmdbernehmen.Enabled = False
    ElseIf Termindatum = Date Then
        TerminUhrzeitprfen
    Else
        .cmdbernehmen.Enabled = True
    End If
End With
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Public Sub TerminUhrzeitprfen()
On Error GoTo Fehlerbehandlung
Dim Vergleichsdatum As Date
With FrmTermine
Vergleichsdatum = .lblTerminDatum.Caption
    If Date >= Vergleichsdatum And Stunde & ":" & Minute & ":00" < Time Then
        FehlerSound
        .cmdbernehmen.Enabled = False
    Else
        Clicksound
        .cmdbernehmen.Enabled = True
    End If
End With
Exit Sub
Fehlerbehandlung:
End Sub

Public Sub TerminaufVorhandenseinprfen()
With FrmTermine
    'in der Schleife prfen ob der Termin mit _
    gleicher Uhrzeit bereits vorhanden ist
    For I = 0 To FrmKalender.lstTerminDatum.ListCount - 1
        If FrmKalender.lstTerminDatum.List(I) = .lblTerminDatum.Caption _
        And FrmKalender.lstTerminUhrzeit.List(I) = .lblTerminuhrzeit.Caption Then
            'der Variable den entsprechenden Wert zuweisen
            Terminvorhanden = True
            'Schleife verlassen
            Exit For
        Else
            Terminvorhanden = False
        End If
    Next
End With
End Sub

Public Sub Terminanlegen()
With FrmTermine
    'wenn mehr als 1 Termin eingetragen ist ...
    If FrmKalender.lstTerminDatum.ListCount > 1 Then
        TerminaufVorhandenseinprfen
    End If
    'den Wert der Variable abfragen
    If Terminvorhanden = True Then
        FrageSound
        If MsgBox("ein Termin ist bereits am " _
        & FrmKalender.lstTerminDatum.List(I) & " um " _
        & FrmKalender.lstTerminUhrzeit.List(I) & " Uhr vergeben !" & Chr(13) _
        & Chr(13) & "Terminart:" & vbTab & vbTab _
        & FrmKalender.lstTerminart.List(I) & Chr(13) _
        & "Terminbeschreibung:" & vbTab _
        & FrmKalender.lstTerminbeschreibung.List(I) _
        & Chr(13) & Chr(13) & "Soll er trotzdem bernommen werden ?", _
        vbQuestion + vbYesNo + vbDefaultButton2, _
        "Termin ist bereits vergeben") = vbYes Then
            AnnehmenSound
            FrmKalender.lstTerminDatum.AddItem .lblTerminDatum.Caption
            FrmKalender.lstTerminUhrzeit.AddItem .lblTerminuhrzeit.Caption
            FrmKalender.lstTerminart.AddItem .cboTerminart.Text
            FrmKalender.lstTerminbeschreibung.AddItem .txtTerminBeschreibung.Text
        Else
            AblehnenSound
            Exit Sub
        End If
    Else

        DatummitFeiertagVergleichen Right(.lblTerminDatum.Caption, 4), .lblTerminDatum.Caption
        
        If DatumamFeiertag = False Then
            FrmKalender.lstTerminDatum.AddItem .lblTerminDatum.Caption
            FrmKalender.lstTerminUhrzeit.AddItem .lblTerminuhrzeit.Caption
            FrmKalender.lstTerminart.AddItem .cboTerminart.Text
            FrmKalender.lstTerminbeschreibung.AddItem .txtTerminBeschreibung.Text
        Else
            FrageSound
            If MsgBox("dein Termin am " & .lblTerminDatum.Caption _
            & " ist an einem Feiertag !" & Chr(13) & "Feiertagname : " _
            & strFeiertag & Chr(13) & Chr(13) _
            & "Soll der Termin trotzdem angenommen werden ?", _
            vbQuestion + vbYesNo + vbDefaultButton1, _
            "Termin an einem Feiertag") = vbYes Then
                AnnehmenSound
                FrmKalender.lstTerminDatum.AddItem .lblTerminDatum.Caption
                FrmKalender.lstTerminUhrzeit.AddItem .lblTerminuhrzeit.Caption
                FrmKalender.lstTerminart.AddItem .cboTerminart.Text
                FrmKalender.lstTerminbeschreibung.AddItem .txtTerminBeschreibung.Text
            Else
                AblehnenSound
            End If
        End If
    End If
End With
End Sub

Public Sub SerienTermineanlegen()
On Error GoTo Fehlerbehandlung
Dim j As Long
Dim WochentagIndex As Integer

SerienTerminDatumVorhanden = False

With FrmTermine
    Seriendatum = .lblTerminDatum.Caption
    SerienUhrzeit = .lblTerminuhrzeit.Caption
    
    If .cboSerienTermin.ListIndex > 0 Then
        'Schleife entsprechend dem gewhlten ListenIndex mal ausfhren
        For I = 1 To (.cboSerienTermin.ListIndex) * 7
            'die Anzahl der vorhandenen Eintrge prfen
            If FrmKalender.lstTerminDatum.ListCount > 1 Then
                'nur wenn mehr als 1 Eintrag (Termin) vorhanden ist ausfhren
                For j = 0 To FrmKalender.lstTerminDatum.ListCount - 1
                    'vergleichen
                    If FrmKalender.lstTerminDatum.List(j) = Seriendatum _
                    And FrmKalender.lstTerminUhrzeit.List(j) = SerienUhrzeit Then
                        SerienTerminDatumVorhanden = True
                        Exit For
                    Else
                        SerienTerminDatumVorhanden = False
                    End If
                Next
            End If
            
                DatummitFeiertagVergleichen Right(Seriendatum, 4), Seriendatum
                
            'die Wochentage durchlaufen
            For WochentagIndex = 0 To 6
                'auf entsprechenden Wochentag prfen
                If Format(Seriendatum, "dddd") = .chkWochentag(WochentagIndex).Caption Then
                    'prfen auf als Ausnahme aktiviert oder nicht
                    If .chkWochentag(WochentagIndex).Value = 0 Then
                        'wenn nicht als Ausnahme aktiviert dann ...
                        SerienTerminDateneinfgen j
                    End If  'Ende auf als Ausnahme prfen
                End If  'Ende auf Wochentag prfen
            Next
            Seriendatum = DateAdd("d", 1, Seriendatum)
        Next
    End If
End With
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Public Sub DatummitFeiertagVergleichen(ByVal Jahr As Integer, ByVal Datum As Date)

DatumamFeiertag = False
Jahr = Right(Datum, 4)
Neujahr = "01.01." & Jahr
HeiligeDreiKnige = "06.01." & Jahr
ErsterMai = "01.05." & Jahr
TgdtEinheit = "03.10." & Jahr
Allerheiligen = "01.11." & Jahr
'Dim Weihnachten As Date
'Weihnachten = "24.12." & TerminJahr
ErsterWeihnachtsfeiertag = "25.12." & Jahr
ZweiterWeihnachtsfeiertag = "26.12." & Jahr

Select Case Datum
    Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Aschermittwoch)
        DatumamFeiertag = True
        strFeiertag = "Aschermittwoch"
        
    Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Karfreitag)
        DatumamFeiertag = True
        strFeiertag = "Karfreitag"
        
    Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Ostersonntag)
        DatumamFeiertag = True
        strFeiertag = "Ostersonntag"
        
    Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Ostermontag)
        DatumamFeiertag = True
        strFeiertag = "Ostermontag"
        
    Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Christihimmelfahrt)
        DatumamFeiertag = True
        strFeiertag = "Christihimmelfahrt"
        
    Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Pfingstsonntag)
        DatumamFeiertag = True
        strFeiertag = "Pfingstsonntag"
        
    Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Pfingstmontag)
        DatumamFeiertag = True
        strFeiertag = "Pfingstmontag"
        
    Case FeiertagDatum(intJahr:=Jahr, Feiertag:=Fronleichnam)
        DatumamFeiertag = True
        strFeiertag = "Fronleichnam"
        
    Case Neujahr
        DatumamFeiertag = True
        strFeiertag = "Neujahr"
        
    Case HeiligeDreiKnige
        DatumamFeiertag = True
        strFeiertag = "Heilige Drei Knige"
        
    Case ErsterMai
        DatumamFeiertag = True
        strFeiertag = "1. Mai"
        
    Case TgdtEinheit
        DatumamFeiertag = True
        strFeiertag = "Tag der deutschen Einheit"
        
    Case Allerheiligen
        DatumamFeiertag = True
        strFeiertag = "Allerheiligen"
        
    'Case Weihnachten
    '   DatumamFeiertag = True
    '   strFeiertag = "Weihnachten"
    
    Case ErsterWeihnachtsfeiertag
        DatumamFeiertag = True
        strFeiertag = "1. Weihnachtsfeiertag"
        
    Case ZweiterWeihnachtsfeiertag
        DatumamFeiertag = True
        strFeiertag = "2. Weihnachtsfeiertag"
        
    Case Else
        DatumamFeiertag = False
        strFeiertag = ""
End Select
End Sub

Private Sub SerienTerminDateneinfgen(ByVal j As Long)
With FrmTermine
    If SerienTerminDatumVorhanden = False Then
        If DatumamFeiertag = False Then
            FrmKalender.lstTerminDatum.AddItem Seriendatum
            FrmKalender.lstTerminUhrzeit.AddItem .lblTerminuhrzeit.Caption
            FrmKalender.lstTerminart.AddItem .cboTerminart.Text
            FrmKalender.lstTerminbeschreibung.AddItem .txtTerminBeschreibung.Text
        Else
            FrageSound
            If MsgBox("dein Termin am " & Seriendatum _
            & " ist an einem Feiertag !" & Chr(13) & "Feiertagname : " _
            & strFeiertag & Chr(13) & Chr(13) _
            & "Soll der Termin trotzdem angenommen werden ?", _
            vbQuestion + vbYesNo + vbDefaultButton1, _
            "Termin an einem Feiertag") = vbYes Then
                AnnehmenSound
                FrmKalender.lstTerminDatum.AddItem Seriendatum
                FrmKalender.lstTerminUhrzeit.AddItem .lblTerminuhrzeit.Caption
                FrmKalender.lstTerminart.AddItem .cboTerminart.Text
                FrmKalender.lstTerminbeschreibung.AddItem .txtTerminBeschreibung.Text
            Else
                AblehnenSound
            End If
        End If
    Else
        FrageSound
        If MsgBox("ein Termin ist bereits am " _
        & FrmKalender.lstTerminDatum.List(j) & " um " _
        & FrmKalender.lstTerminUhrzeit.List(j) & " Uhr vergeben !" & Chr(13) _
        & Chr(13) & "Terminart:" & vbTab & vbTab _
        & FrmKalender.lstTerminart.List(j) & Chr(13) _
        & "Terminbeschreibung:" & vbTab _
        & FrmKalender.lstTerminbeschreibung.List(j) _
        & Chr(13) & Chr(13) & "Soll er trotzdem bernommen werden ?", _
        vbQuestion + vbYesNo + vbDefaultButton2, _
        "Termin ist bereits vergeben") = vbYes Then
            AnnehmenSound
            FrmKalender.lstTerminDatum.AddItem Seriendatum
            FrmKalender.lstTerminUhrzeit.AddItem .lblTerminuhrzeit.Caption
            FrmKalender.lstTerminart.AddItem .cboTerminart.Text
            FrmKalender.lstTerminbeschreibung.AddItem .txtTerminBeschreibung.Text
        Else
            AblehnenSound
        End If
    End If
End With
End Sub
